Bug 76381 - [ILK Bisected]Piglit shaders/glsl-fs-normalmatrix fails
Summary: [ILK Bisected]Piglit shaders/glsl-fs-normalmatrix fails
Status: VERIFIED FIXED
Alias: None
Product: Mesa
Classification: Unclassified
Component: Drivers/DRI/i965 (show other bugs)
Version: unspecified
Hardware: All Linux (All)
: high major
Assignee: Kenneth Graunke
QA Contact: Intel 3D Bugs Mailing List
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2014-03-20 03:22 UTC by lu hua
Modified: 2014-04-18 06:08 UTC (History)
2 users (show)

See Also:
i915 platform:
i915 features:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description lu hua 2014-03-20 03:22:35 UTC
System Environment:
--------------------------
Platform: Ironlake
Libdrm:		(master)libdrm-2.4.52-9-g230389a0d7b712f8ad0bab6edaacd8988e64d76b
Mesa:		(master)651b8baa826609ca3a305a3cbcd085435931573c
Xserver:		(master)xorg-server-1.15.99.901-96-gd18d3f6d18aa7827748f7ba14efd405b525883d0
Xf86_video_intel:		(master)2.99.910-112-g15be6b7c9a89bfdac923d2a27649f539c430366f
Cairo:		(master)8e11a42e3e9b679dce97ac45cd8b47322536a253
Libva:		(staging)bf2e1773d4373619232c4c653b8cda19ea329441
Libva_intel_driver:		(staging)abd77ff2014322d152d723a3e8b1cba1e41b0a5f
Kernel:	(drm-intel-nightly)d6fb8438c5f136231283d7978505754f8f6f7d5f

Bug detailed description:
-----------------------------
It fails on Ironlake with mesa master branch, and works well on 10.1 branch.
Following cases also fail with same bisect commit:
shaders_glsl-fs-uniform-array-2
shaders_glsl-fs-uniform-array-6
shaders_glsl-fs-uniform-array-7

Bisect shows: b207e88b25e526d0f1ada7b19605b880a27866dc is the first bad commit.
commit b207e88b25e526d0f1ada7b19605b880a27866dc
Author:     Kenneth Graunke <kenneth@whitecape.org>
AuthorDate: Fri Mar 7 16:10:50 2014 -0800
Commit:     Kenneth Graunke <kenneth@whitecape.org>
CommitDate: Tue Mar 18 10:11:36 2014 -0700

    i965/fs: Support pull parameters in SIMD16 mode.

    This is just a matter of reusing the pull/push constant information set
    up by the SIMD8 compile.

    This gains us 78 SIMD16 programs in shader-db.

    Signed-off-by: Kenneth Graunke <kenneth@whitecape.org>
    Reviewed-by: Topi Pohjolainen <topi.pohjolainen@intel.com>

output:
Probe color at (31,125)
  Expected: 1.000000 0.000000 0.000000 0.000000
  Observed: 0.000000 1.000000 0.000000 0.000000
Probe color at (93,125)
  Expected: 0.000000 1.000000 0.000000 0.000000
  Observed: 0.000000 0.000000 0.000000 0.000000
PIGLIT: {'result': 'fail' }


Reproduce steps:
----------------------------
1. xinit
2. ./bin/shader_runner tests/shaders/glsl-fs-normalmatrix.shader_test -auto
Comment 1 Kenneth Graunke 2014-04-16 08:30:19 UTC
Patch on mailing list:
http://lists.freedesktop.org/archives/mesa-dev/2014-April/057888.html
Comment 2 Kenneth Graunke 2014-04-17 17:54:36 UTC
Fixed by:

commit 71846a943f9b699d0f234d919dcb8d1934943693
Author: Kenneth Graunke <kenneth@whitecape.org>
Date:   Wed Apr 16 20:15:23 2014 -0700

    i965: Retype pre-Gen6 varying pull load destination to UW.
    
    This sets up the proper execution mask for sends in SIMD16 mode.
    
    Fixes Piglit's glsl-fs-normalmatrix, glsl-fs-uniform-array-2,
    glsl-fs-uniform-array-6, and glsl-fs-uniform-array-7 on Ironlake,
    which regressed when I enabled SIMD16 pull parameter support in
    commit b207e88b25e526d0f1ada7b19605b880a27866dc.
    
    Signed-off-by: Kenneth Graunke <kenneth@whitecape.org>
    Reviewed-by: Eric Anholt <eric@anholt.net>
Comment 3 lu hua 2014-04-18 06:08:22 UTC
Verified.Fixed.


Use of freedesktop.org services, including Bugzilla, is subject to our Code of Conduct. How we collect and use information is described in our Privacy Policy.